<?php

/*
Plugin Name: yDom
Plugin URI: http://www.jluster.org
Description: Fetch Yahoo! API Stuff
Version: 0.01
Author: Jonas M Luster
Author URI: http://www.jluster.org/
*/

$APPID = "";
$CACHE_PATH = "/usr/u/www/blog/tcache"; /* must be accessible and writable to the webserver */
$CACHE_TIMEOUT = 6 * 60 * 60;           /* six hours, split out for easy editing :) */

$services = array('image'=>'http://api.search.yahoo.com/ImageSearchService/V1/imageSearch',
                 'local'=>'http://api.local.yahoo.com/LocalSearchService/V1/localSearch',
                 'news'=>'http://api.search.yahoo.com/NewsSearchService/V1/newsSearch',
                 'video'=>'http://api.search.yahoo.com/VideoSearchService/V1/videoSearch',
                 'web'=>'http://api.search.yahoo.com/WebSearchService/V1/webSearch');

if (empty($APPID)) {
  print "Set your APPID";
  exit;
}

/* CONFIG ENDS HERE */
function ydom($search, $service='news', $max='10', $before='<li>', $after='</li>', $zipcode='94404') {
  global $services, $SEARCH_LIMIT, $CACHE_TIMEOUT, $CACHE_PATH, $APPID;
  
	if (!array_key_exists($service, $services)) {
		$output = "${before}Cannot render unknown service $service.${after}";
		$errorcode = "1";
		render($output, $errorcode);
		return($errorcode);
	}
	if (empty($search)) {
		$output = "${before}Cannot render empty search string.${after}";
		$errorcode = "2";
		render($output, $errorcode);		
		return($errorcode);
	}

	$q = '?query='.rawurlencode($search);
	if(!empty($zipcode)) $q.="&zip=".$zipcode;
	$q .= "&appid=$APPID";
	$q .= "&results=$max";

	$xml = yahoo_get_contents($services[$service].$q,'r', $CACHE_TIMEOUT, $CACHE_PATH, 0);

	if (!$dom = domxml_open_mem($xml,DOMXML_LOAD_PARSING,$error)) {
	  $output = "${before}XML parse error${after}";
	  foreach ($error as $errorline) {
      $output .= "${before}".$errorline['errormessage']."${after}";
	  }
	  $errorcode = "4";
	  render($output, $errorcode);
	}
	
	$res = yahooxml_to_result($dom);
	
	for($i=0; $i<$res['totalResultsReturned']; $i++) {
    foreach($res[$i] as $key => $value) {
      $tag = strtolower($key);
      switch($tag) {
        case 'title':
          $title = $value;
          break;
        case 'url':
          $url = $value;
          break;
        case 'newssource':
          $newssource = $value;
          break;
        case 'refererurl':
          $refurl = $value;
          break;
        case 'summary':
          $summary = $value;
          break;
        case 'address':
          $address = $value;
          break;
        case 'city':
          $city = $value;
          break;
        case 'state':
          $state = $value;
          break;
        case 'resultsetmapurl':
          $map = $value;
          break;
        case 'distance':
          $distance = $value;
          break;
        case 'businessurl':
          $businessurl = $value;
          break;

      }
    }
    if ($service == 'image') {
      $output .= "${before}<a href='$refurl'><img src='$url' /></a>${after}";
    }
    elseif ($service == 'local'){
      $linkurl = $businessurl ? $businessurl : $url;
      $businessurl = "";
      $output .= "${before}<a href='$linkurl'>$title</a> ($distance miles) [<a hreg='$map'>map</a>]${after}";
    }
    else {
      $output .= "${before}<a href='$url'>$title</a>";
      if ($service == 'news') {
        $output .= " [$newssource]";
      }
      $output .= "${after}";
    }
  }
  render($output);
}

function render($content, $error='0') {
  if ($error) {
    print $content;
  }
  else {
    print $content;
  }
}

function yahoo_get_contents($file, $file_mode, $cache_to, $cache_pa, $debug = false) {
	clearstatcache();
	$cache_filename = $cache_pa . "/" . urlencode($file) .".cached";
	if (( @file_exists($cache_filename) && (( @filemtime($cache_filename) + $cache_to) > ( time())))) 
	{ /* TODO: stats code */ } 
	else {
		$f = fopen($file,"r"); 
		$f2 = fopen($cache_filename,"w+"); 
		while ($r = fread($f,8192)) { fwrite($f2,$r); }
		fclose($f2);
		fclose($f);
	}
	return file_get_contents ($cache_filename);
}

function yahooxml_to_result($dom) {
  $root = $dom->document_element();
  $res['totalResultsAvailable'] = $root->get_attribute('totalResultsAvailable');
  $res['totalResultsReturned'] = $root->get_attribute('totalResultsReturned');
  $res['firstResultPosition'] = $root->get_attribute('firstResultPosition');

  $node = $root->first_child();
  $i = 0;
  while($node) {
    switch($node->tagname) {
      case 'Result':
        $subnode = $node->first_child();
        while($subnode) {
          $subnodes = $subnode->child_nodes();
          if(!empty($subnodes)) foreach($subnodes as $k=>$n) {
            if(empty($n->tagname)) $res[$i][$subnode->tagname] = trim($n->get_content());
            else $res[$i][$subnode->tagname][$n->tagname]=trim($n->get_content());
          }
          $subnode = $subnode->next_sibling();
        }
        break;
      default:
        $res[$node->tagname] = trim($node->get_content());
        $i--;
        break;
    }
    $i++;
    $node = $node->next_sibling();
  }  
  return $res;
}

?>
